#!/usr/bin/env python
from smtplib import SMTP_SSL
from getpass import getpass
from email.message import EmailMessage
from email.policy import EmailPolicy
from email.utils import formatdate
from configparser import ConfigParser
import csv, logging

with open('mailing.txt') as f:
    sujet=f.readline().strip()
    texte=f.read(-1)

conf=ConfigParser()
conf.read('mailing.conf')
if 'port' not in conf['server']:
    conf['server']['port']='465'
if 'passwd' not in conf['server']:
   conf['server']['passwd']=getpass()
if 'bcc' not in conf['mail']:
   conf['mail']['bcc']='false'

def envoie(serveur,port,login,mdp,sujet,corps,emet,dest,dobcc,pdf_path,filename):
    msg=EmailMessage(EmailPolicy(utf8=False))
    msg['Subject']=sujet
    msg['From']=emet
    msg['To']=dest
    msg['Date']=formatdate(localtime=True)
    if dobcc:
        msg['Bcc']=emet
    msg.set_content(corps)
    with open(pdf_path,'rb') as f:
        dapdf=f.read(-1)
    msg.add_attachment(dapdf, maintype='application', subtype='pdf', filename=filename)
    with SMTP_SSL(serveur,port) as server:
        server.login(login,mdp)
        try:
            server.send_message(msg)
            logging.info('{}: OK'.format(dest))
        except Exception as e:
            logging.error('{} : {}'.format(dest,str(e)))
            print('ERROR ON {}'.format(dest))

logging.basicConfig(filename='mailing.log',level=logging.DEBUG,format='%(asctime)s %(message)s')
logging.info('==== Début du mailing ====')
with open('mailing.csv',newline='') as f:
    reader=csv.reader(f)
    for row in reader:
        print('{}...'.format(row[0]))
        envoie(conf['server']['hostname'],int(conf['server']['port']),conf['server']['login'],conf['server']['passwd'],
               sujet,texte.format(*row[3:]),conf['mail']['sender'],row[0],conf['mail']['bcc']=='true',row[1],row[2])
logging.info('==== Fin du mailing ====')
